/**
 * Created by Administrator on 2019-9-7.
 */
//请求数据命令
var  USER_LOGIN_V25 = 1200;//用户登录
var USER_MODIFY_BYID_V25 = 1201;//修改单项ID
var USER_MODIFY_BYDOUBLEID_V25 = 1202;//修改双项ID
var ACCOUNT_GETBYID_V26 = 2027;//获取用户个人信息
var ACCOUNT_SEARCH_USER_V26 = 2028;//查询子用户信息
var ACCOUNT_SUBUSER_LIST_V26 = 2005;//管理子用户列表
var ACCOUNT_PROJECT_LIST_V26 = 2006;//用户项目列表
var ACCOUNT_PROJECT_STATION_LIST_V26 = 2007;//项目站点列表
var CREATE_ACCOUNT_V26 = 2001;//创建账户
var DELETE_ACCOUNT_V26 = 2002;//删除账户
var MODIFY_ACCOUNT_PASSWORD_V26 = 2003;//修改密码
var RESET_ACCOUNT_PASSWORD_V26 = 2004;//重置密码，默认123456
var PROJECT_AUTH_DELETE_V26 = 2015;//删除集团、项目权限
var PROJECT_AUTH_MOD_V26 = 2016;//修改集团、项目权限
var STATION_USER_DELETE_V26 = 2022;//删除站点权限

var ACCOUNT_GROUP_LIST_V26 = 2008;//获取集团列表
var ACCOUNT_PROJECT_GETBYID_V26 = 2009;//修改集团、项目获取集团、项目信息
var ACCOUNT_GROUP_SUBPROJ_CONTENT_V26 = 2010;//集团子项目内容
var ACCOUNT_APPLY_ID_V26 = 2029;//用户申请项目/站ID
var ACCOUNT_CREATE_PROJECT_V26 = 2011;//新建集团、项目
var ACCOUNT_DELETE_PROJECT_V26 = 2012;//删除集团、项目
var ACCOUNT_PROJECT_AUTH_LIST_V26 = 2013;//项目用户权限列表
var PROJECT_AUTH_ADD_V26 = 2014;//集团、项目授权
var STATION_CREATE_V26 = 2017;//创建站点
var STATION_DELETE_V26 = 2018;//删除站点
var ACCOUNT_STATION_AUTH_LIST_V26 = 2019;//获取站点用户权限列表
var STATION_USER_ADD_V26 = 2020;//站点授权
var STATION_USER_MODIFY_V26 = 2021;//修改站点权限
var ACCOUNT_STATION_GETBYID_V26 = 2030;//修改站点时获取单个站点信息
var USER_24HFOCUS_LIST_GETBYID = 1219;//获取24小时责任人列表
var USER_24HFOCUS_CREATE = 1220;//创建24小时责任人列表
var USER_24HFOCUS_DELETE = 1221;//删除24小时责任人列表

var ACCOUNT_DEVICE_ITEM_LIST_V26 = 2023;//设备分项列表
var DEVICE_ITEM_CREATE_V26 = 2024;//新建设备分项
var DEVICE_ITEM_MODIFY_V26 = 2025;//修改设备分项
var DEVICE_ITEM_DELETE_V26 = 2026;//删除设备分项
var ACCOUNT_GET_PARATBL = 2031;//获取设备服务器配置
var ACCOUNT_COMMIT_PARAM = 2032;//提交修改设备服务器配置
var ACCOUNT_DELETE_PARAM = 2033;//删除设备服务器配置
var ACCOUNT_PRODUCT_LIST_V25 = 1232;//2.33	获取所有厂家列表

var PRODUCT_CREATE_V26 = 2034;//创建厂家
var PRODUCT_DELETE_V26 = 2035;//删除厂家

var MODEL_RULE_CREATE_V26 = 2036;//创建型号
var MODEL_RULE_DELETE_V26 = 2037;//删除型号
var ACCOUNT_GET_CONFIGBYID = 2038;//按型号获取协议配置
var ACCOUNT_SAVE_CONFIGBYID = 2039;//按型号保存协议配置
var ACCOUNT_DEVICE_MODEL_LIST_V26 = 2040;//获取厂家型号列表
var USER_MODIFY_BYDOUBLEID_STRKEY = 2048;//双字符串修改ID
var USER_GROUP_EXTEND_GETBYID = 2053;//获取集团附加内容
var ACCOUNT_GET_MODEL_CONTROL_LIST_V26 = 2054;//按ID获取遥控遥调规则列表
var ACCOUNT_GET_MAX_YKT_NUMBER_V26 = 2055;//取最大遥控遥调指令编号
var MODEL_CONTROL_MODIFY_V26 = 2057;//添加、修改遥控遥调单条指令
var MODEL_CONTROL_DELETE_V26 = 2058;//删除遥控遥调
var ACCOUNT_GET_MODEL_RULE_CONFIG_V25 = 1313;//按ID获取配电设备上报采集规则(1313) 
var MODEL_RULE_CONFIG_SAVE_V25 = 1314;//2.112	按ID获取配电设备上报采集规则

var STATION_MENU_LIST_GETBYID = 1316;//2.114	获取站点菜单列表
var STATION_MENU_MODBYID = 1317;//2.115	按ID修改站点菜单信息
var STATION_USER_MENU_LIST_GETBYID = 1318;//2.116	站点用户菜单列表
var STATION_USER_MENU_MODBYID = 1319;//2.117	按ID修改站点用户菜单信息
/*---------------------------------------
 * 清除字符串中所有空格，包含换行符、制表符
 *---------------------------------------*/
function RemoveAllSpace1(str) {
    return str.replace(/\s/g,"").replace(/\n/g,"").replace(/\t/g,"");
}

/*---------------------------------------
 * 字符串中添加空格
 *---------------------------------------*/
function StringAddSpace1(str) {
    var strRet = "";
    var nPos = 0;

    while(nPos < str.length-2)
    {
        strRet += str.substr(nPos, 2);
        strRet += ' ';
        nPos+=2;
    }

    strRet += str.substr(nPos, 2);

    return strRet;
}

/*------------------------------------------------------------
 * 将数字转换成N位字符串格式,不够前面补0，如N=2，1->"01"
 *------------------------------------------------------------*/
function NumToStringN(num,len) {
    var str = "0000000000" + num;
    str = str.substring(str.length - len);//输出01就-2
    return str;
}


/*------------------------------------------------------------
 * 浮点数转换成5长度字符串，特定的浮点数0.001、0.01、0.1、1.0、10.0、100.0
 *------------------------------------------------------------*/
function RatioToString5(f) {
    var Large = f * 1000;
    var Integer = parseInt(Large);
    var strRet = "";
    switch (Integer) {
        case 1:
            strRet = "0.001";
            break;
        case 10:
            strRet = "0.010";
            break;
        case 100:
            strRet = "0.100";
            break;
        case 1000:
            strRet = "1.000";
            break;
        case 10000:
            strRet = "10.00";
            break;
        case 100000:
            strRet = "100.0";
            break;
        default: strRet = "0.000";break;
    }

    return strRet;
}

/*------------------------------------------------------------
 *5长度字符串转换成浮点数，特定的浮点数0.001、0.01、0.1、1.0、10.0、100.0
 *------------------------------------------------------------*/
function String5ToRatio(strBuf)
{
    var f = 0.0;
    if(strBuf == "0.001") {
        f = 0.001;
    }else
    if (strBuf == "0.010"){
        f = 0.01;
    }else
    if (strBuf == "0.100"){
        f = 0.1;
    }else
    if (strBuf == "1.000"){
        f = 1.0;
    }else
    if (strBuf == "10.00"){
        f = 10.0;
    }else
    if (strBuf == "100.0"){
        f = 100.0;
    }else
    {
        f = 0.000;
    }

    return f;
}

/*------------------------------------------------------------
 *数字转换为十六进制字符串
 *------------------------------------------------------------*/
function NumToHexStringN(num, len)
{
    var HexString = "0000000000" + (parseInt(num).toString(16)).toUpperCase();
    return HexString.substring(HexString.length - len);
}
/*------------------------------------------------------------
 *十六进制字符串转换为数字
 *------------------------------------------------------------*/
function HexStringToNum(str)
{
    return parseInt(str, 16);
}